Интеграция с React
Прежде чем читать эту документацию, ознакомьтесь с базовыми концепциями и шаблонами React. Для обновления знаний обратитесь к документации React.
DHTMLX To Do List совместим с React. Приведённые ниже примеры показывают, как использовать их вместе. Полный проект доступен в примере на GitHub.
Создание проекта
Создайте новый проект React и установите зависимости.
Создайте базовый проект React или используйте React с Vite. В примере ниже проект называется my-react-todo-app:
npx create-react-app my-react-todo-app
Установка зависимостей
Перейдите в директорию созданного приложения:
cd my-react-todo-app
Установите завис имости и запустите сервер разработки с помощью менеджера пакетов.
Выполните следующие команды с yarn:
yarn
yarn start
Выполните следующие команды с npm:
npm install
npm start
Приложение запускается по адресу localhost (например, http://localhost:3000).
Создание To Do List
Остановите приложение и установите пакет To Do List.
Шаг 1. Установка пакета
Загрузите пробный пакет To Do List и следуйте инструкциям в файле README. Пробная версия доступна только 30 дней.
Шаг 2. Создание компонента
Создайте React-компонент для добавления To Do List с Toolbar в приложение. В директории src/ создайте новый файл ToDo.jsx.
Импорт исходных файлов
Откройте ToDo.jsx и импортируйте исходные файлы To Do List. Выберите один из двух путей импорта:
- PRO-версия, установленная из локальной папки - импорт из
dhx-todolist-package - пробная версия - импорт из
@dhx/trial-todolist
Пример ниже импортирует из PRO-пакета:
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
В зависимости от пакета исходные файлы могу т быть минифицированы. В таком случае импортируйте CSS-файл как todo.min.css.
Следующий фрагмент импортирует из пробного пакета:
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import "@dhx/trial-todolist/dist/todo.css";
В этом руководстве используется пробная версия.
Настройка контейнеров и добавление To Do List с Toolbar
Чтобы отобразить To Do List с Toolbar на странице, создайте контейнеры для обоих компонентов и инициализируйте их с помощью конструкторов. Пример ниже рендерит оба контейнера и инициализирует компоненты внутри useEffect:
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css"; // подключение стилей To Do List
export default function ToDoComponent(props) {
let toolbar_container = useRef(); // инициализация контейнера для Toolbar
let todo_container = useRef(); // инициализация контейнера для To Do List
useEffect(() => {
// инициализация компонента To Do List
const todo = new ToDo(todo_container.current, {});
// инициализация компонента Toolbar
const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api, // передача внутреннего API To Do List
// другие свойства конфигурации
});
return () => {
todo.destructor(); // уничтожение To Do List
toolbar.destructor(); // уничтожение Toolbar
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}
Добавление стилей
Настройте стили, чтобы To Do List отображался корректно. Используйте файл index.css для задания стилей To Do List и его контейнеров. Пример ниже определяет размеры макета страницы:
/* стили для начальной страницы */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}
/* стили для контейнера To Do List и Toolbar */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}
/* стили для контейнера To Do List */
.widget {
height: calc(100% - 56px);
}
Загрузка данных
Создайте файл data.js в директории src/ и добавьте в него данные. Следующий пример экспортирует функцию getData(), которая возвращает задачи, пользователей и проекты:
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}
Откройте App.js и импортируйте данные. Передайте данные в компонент <ToDo/> как props, как показано ниже:
import ToDo from "./ToDo";
import { getData } from "./data";
function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}
export default App;
Перейдите в ToDo.jsx и примените переданные props к объекту конфигурации To Do List. Фрагмент ниже передаёт данные пользователей, задач и проектов через конфигурацию:
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";
export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();
useEffect(() => {
const todo = new ToDo(todo_container.current, {
users: props.users,
tasks: props.tasks,
projects: props.projects,
// другие свойства конфигурации
});
const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// другие свойства конфигурации
});
return () => {
todo.destructor();
toolbar.destructor();
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}
Вы также можете использовать метод parse() внутри useEffect() для загрузки данных в To Do List. Пример ниже загружает данные с помощью parse() после инициализации:
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";
export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();
let tasks = props.tasks;
let users = props.users;
let projects = props.projects;
useEffect(() => {
const todo = new ToDo(todo_container.current, {});
const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// другие свойства конфигурации
});
todo.parse({ tasks, users, projects });
return () => {
todo.destructor();
toolbar.destructor();
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}
Каждый вызов parse(data) заменяет текущий набор данных.
Теперь компонент отображает заполненный To Do List. Другие доступные свойства описаны в обзоре конфигурации.
Обработка событий
Подпишитесь на события, чтобы реагировать на действия пользователя. Смотрите полный список событий.
Откройте ToDo.jsx и дополните метод useEffect(). Фрагмент ниже прикрепляет обработчик к событию add-task:
// ...
useEffect(() => {
const todo = new ToDo(todo_container.current, {});
todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
return () => {
todo.destructor();
};
}, []);
// ...
Шаг 3. Добавление To Do List в приложение
Чтобы добавить компонент в приложение, откройте App.js и замените код по умолчанию следующим фрагментом:
import ToDo from "./ToDo";
import { getData } from "./data";
function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}
export default App;
Запустите приложение. To Do List отобразится с тестовыми данными:

Полный проект доступен на GitHub.

Перейти к основному содержимому

Интеграция с Svelte

Подсказка

Прежде чем читать эту документацию, ознакомьтесь с базовыми концепциями и шаблонами Svelte. Для обновления знаний обратитесь к документации Svelte.

DHTMLX To Do List совместим с Svelte. Приведённые ниже примеры показывают, как использовать их вместе. Полный проект доступен в примере на GitHub.

Создание проекта

Создайте новый проект Svelte и установите зависимости.

К сведению

Перед созданием нового проекта установите Vite (необязательно) и Node.js.

Создайте проект Svelte одним из двух способов:

  • используйте SvelteKit
  • используйте Svelte с Vite без SvelteKit

Пример ниже создаёт проект Svelte + Vite:

npm create vite@latest

Подробности смотрите в соответствующей статье.

Установка зависимостей

Назовите проект my-svelte-todo-app и перейдите в директорию приложения:

cd my-svelte-todo-app

Установите зависимости и запустите сервер разработки с помощью менеджера пакетов.

Выполните следующие команды с yarn:

yarn
yarn start

Выполните следующие команды с npm:

npm install
npm run dev

Приложение запускается по адресу localhost (например, http://localhost:3000).

Создание To Do List

Остановите приложение и установите пакет To Do List.

Шаг 1. Установка пакета

Загрузите пробный пакет To Do List и следуйте инструкциям в файле README. Пробная версия доступна только 30 дней.

Шаг 2. Создание компонента

Создайте Svelte-компонент для добавления To Do List с Toolbar в приложение. В директории src/ создайте новый файл ToDo.svelte.

Импорт исходных файлов

Откройте ToDo.svelte и импортируйте исходные файлы To Do List. Выберите один из двух путей импорта:

  • PRO-версия, установленная из локальной папки - импорт из dhx-todolist-package
  • пробная версия - импорт из @dhx/trial-todolist

Пример ниже импортирует из PRO-пакета:

ToDo.svelte
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>

В зависимости от пакета исходные файлы могут быть минифицированы. В таком случае импортируйте CSS-файл как todo.min.css.

Следующий фрагмент импортирует из пробного пакета:

ToDo.svelte
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>

В этом руководстве используется пробная версия.

Настройка контейнеров и добавление To Do List с Toolbar

Чтобы отобразить To Do List с Toolbar на странице, создайте контейнеры для обоих компонентов и инициализируйте их с помощью конструкторов. Пример ниже привязывает контейнеры и инициализирует компоненты внутри onMount:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

let toolbar_container, todo_container; // инициализация контейнеров для To Do List и Toolbar
let todo, toolbar;

onMount(() => {
// инициализация компонента To Do List
todo = new ToDo(todo_container, {})

// инициализация компонента Toolbar
toolbar = new Toolbar(toolbar_container, {
api: todo.api, // передача внутреннего API To Do List
// другие свойства конфигурации
})
});

onDestroy(() => {
todo.destructor(); // уничтожение To Do List
toolbar.destructor(); // уничтожение Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

Загрузка данных

Создайте файл data.js в директории src/ и добавьте в него данные. Следующий пример экспортирует функцию getData(), которая возвращает задачи, пользователей и проекты:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Откройте App.svelte, импортируйте данные и передайте их в компонент <ToDo/> как props:

App.svelte
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";

const { users, tasks, projects } = getData();
</script>

<ToDo {users} {tasks} {projects} />

Перейдите в ToDo.svelte и примените переданные props к объекту конфигурации To Do List. Фрагмент ниже передаёт данные пользователей, задач и проектов через конфигурацию:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export let users;
export let tasks;
export let projects;

let toolbar_container, todo_container;
let todo, toolbar;

onMount(() => {
todo = new ToDo(todo_container, {
users,
tasks,
projects,
// другие свойства конфигурации
})

toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// другие свойства конфигурации
})
});

onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

Вы также можете использовать метод parse() внутри onMount() для загрузки данных в To Do List. Пример ниже загружает данные с помощью parse() после инициализации:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export let users;
export let tasks;
export let projects;

let toolbar_container, todo_container;
let todo, toolbar;

onMount(() => {
todo = new ToDo(todo_container, {})

toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// другие свойства конфигурации
})

todo.parse({ tasks, users, projects });
});

onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

Каждый вызов parse(data) заменяет текущий набор данных.

Теперь компонент отображает заполненный To Do List. Другие доступные свойства описаны в обзоре конфигурации.

Обработка событий

Подпишитесь на события, чтобы реагировать на действия пользователя. Смотрите полный список событий.

Откройте ToDo.svelte и дополните метод onMount(). Фрагмент ниже прикрепляет обработчик к событию add-task:

ToDo.svelte
<script>
// ...
let todo;

onMount(() => {
todo = new ToDo(todo_container, {});

todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
});

onDestroy(() => {
todo.destructor();
});
</script>

// ...

Шаг 3. Добавление To Do List в приложение

Чтобы добавить компонент в приложение, откройте App.svelte и замените код по умолчанию следующим фрагментом:

App.svelte
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";

const { users, tasks, projects } = getData();
</script>

<ToDo {users} {tasks} {projects} />

Запустите приложение. To Do List отобразится с тестовыми данными:

DHTMLX To Do List, отрендеренный в приложении Svelte с демонстрационными данными

Полный проект доступен на GitHub.

Перейти к основному содержимому

Интеграция с Angular

Подсказка

Прежде чем читать эту документацию, ознакомьтесь с базовыми концепциями и шаблонами Angular. Для обновления знаний обратитесь к документации Angular.

DHTMLX To Do List совместим с Angular. Приведённые ниже примеры показывают, как использовать их вместе. Полный проект доступен в примере на GitHub.

Создание проекта

Создайте новый проект Angular и установите зависимости.

К сведению

Перед созданием нового проекта установите Angular CLI и Node.js.

Создайте новый проект my-angular-todo-app с помощью Angular CLI. Выполните следующую команду:

ng new my-angular-todo-app
Примечание

Чтобы следовать этому руководству, отключите Server-Side Rendering (SSR) и Static Site Generation (SSG/Prerendering) при создании нового Angular-приложения.

Команда устанавливает все необходимые инструменты.

Установка зависимостей

Перейдите в директорию созданного приложения:

cd my-angular-todo-app

Установите зависимости и запустите сервер разработки с помощью менеджера пакетов yarn:

yarn
yarn start

Приложение запускается по адресу localhost (например, http://localhost:3000).

Создание To Do List

Остановите приложение и установите пакет To Do List.

Шаг 1. Установка пакета

Загрузите пробный пакет To Do List и следуйте инструкциям в файле README. Пробная версия доступна только 30 дней.

Шаг 2. Создание компонента

Создайте Angular-компонент для добавления To Do List с Toolbar в приложение. В директории src/app/ создайте папку todo и внутри неё файл todo.component.ts.

Импорт исходных файлов

Откройте todo.component.ts и импортируйте исходные файлы To Do List. Выберите один из двух путей импорта:

  • PRO-версия, установленная из локальной папки - импорт из dhx-todolist-package
  • пробная версия - импорт из @dhx/trial-todolist

Следующий фрагмент импортирует из PRO-пакета:

todo.components.ts
import { ToDo, Toolbar } from 'dhx-todolist-package';

Следующий фрагмент импортирует из пробного пакета:

todo.components.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';

В этом руководстве используется пробная версия.

Настройка контейнеров и инициализация To Do List с Toolbar

Чтобы отобразить To Do List с Toolbar на странице, задайте контейнеры для обоих компонентов и инициализируйте их с помощью конструкторов. Пример ниже определяет шаблон, ссылки на контейнеры и инициализирует компоненты внутри ngOnInit():

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist'; 
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo", // имя шаблона, используемое в "app.component.ts" как <todo />
styleUrls: ["./todo.component.css"], // подключение css-файла

template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
// инициализация контейнера для Toolbar
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// инициализация контейнера для To Do List
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
// инициализация компонента To Do List
this._todo = new ToDo(this.todo_container.nativeElement, {});

// инициализация компонента Toolbar
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// другие свойства конфигурации
});
}

ngOnDestroy(): void {
this._todo.destructor(); // уничтожение To Do List
this._toolbar.destructor(); // уничтожение Toolbar
}
}

Добавление стилей

Импортируйте CSS-файл, чтобы To Do List отображался корректно. Создайте файл todo.component.css в директории src/app/todo/ и добавьте стили для To Do List и его контейнера. Фрагмент ниже импортирует стили To Do List и задаёт размеры макета:

todo.component.css
/* импорт стилей To Do List */
@import "@dhx/trial-todolist/dist/todo.css";

/* стили для начальной страницы */
html,
body{
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}

/* стили для контейнера To Do List и Toolbar */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}

/* стили для контейнера To Do List */
.widget {
height: calc(100% - 56px);
}

Загрузка данных

Создайте файл data.ts в директории src/app/todo/ и добавьте в него данные. Следующий пример экспортирует функцию getData(), которая возвращает задачи, пользователей и проекты:

data.ts
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Откройте todo.component.ts, импортируйте файл с данными и передайте свойства данных в объект конфигурации To Do List внутри метода ngOnInit(). Фрагмент ниже применяет данные пользователей, задач и проектов при инициализации:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // инициализация свойств данных
this._todo = new ToDo(this.todo_container.nativeElement, {
users,
tasks,
projects,
// другие свойства конфигурации
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// другие свойства конфигурации
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

Вы также можете использовать метод parse() внутри ngOnInit() для загрузки данных в To Do List. Пример ниже загружает данные с помощью parse() после инициализации:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // инициализация свойств данных
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// другие свойства конфигурации
});

// применение данных через метод parse()
this._todo.parse({
users,
tasks,
projects
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

Каждый вызов parse(data) заменяет текущий набор данных.

Теперь компонент отображает заполненный To Do List. Другие доступные свойства описаны в обзоре конфигурации.

Обработка событий

Подпишитесь на события, чтобы реагировать на действия пользователя. Смотрите полный список событий.

Откройте todo.component.ts и дополните метод ngOnInit(). Фрагмент ниже прикрепляет обработчик к событию add-task:

todo.component.ts
// ...
ngOnInit() {
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._todo.events.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
}

ngOnDestroy(): void {
this._todo.destructor();
}

Шаг 3. Добавление To Do List в приложение

Чтобы добавить ToDoComponent в приложение, откройте src/app/app.component.ts и замените код по умолчанию следующим фрагментом:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<todo/>` // шаблон, созданный в "todo.component.ts"
})
export class AppComponent {
name = "";
}

Создайте файл app.module.ts в директории src/app/ и зарегистрируйте ToDoComponent. Пример ниже объявляет компоненты и запускает приложение:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { ToDoComponent } from "./todo/todo.component";

@NgModule({
declarations: [AppComponent, ToDoComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Последний шаг — открыть src/main.ts и заменить существующий код следующим:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Запустите приложение. To Do List отобразится с тестовыми данными:

DHTMLX To Do List, отрендеренный в приложении Angular с демонстрационными данными

Полный проект доступен на GitHub.

Перейти к основному содержимому

Интеграция с Vue

Подсказка

Прежде чем читать эту документацию, ознакомьтесь с базовыми концепциями и шаблонами Vue. Для обновления знаний обратитесь к документации Vue 3.

DHTMLX To Do List совместим с Vue 3. Приведённые ниже примеры показывают, как использовать их вместе. Полный проект доступен в примере на GitHub.

Создание проекта

Создайте новый проект Vue и установите зависимости.

К сведению

Перед созданием нового проекта установите Node.js.

Чтобы создать проект Vue, выполните следующую команду:

npm create vue@latest

Команда устанавливает и запускает create-vue, официальный инструмент создания проектов Vue. Подробности смотрите в Быстром старте Vue.js.

Назовите проект my-vue-todo-app.

Установка зависимостей

Перейдите в директорию приложения:

cd my-vue-todo-app

Установите зависимости и запустите сервер разработки с помощью менеджера пакетов.

Выполните следующие команды с yarn:

yarn
yarn start

Выполните следующие команды с npm:

npm install
npm run dev

Приложение запускается по адресу localhost (например, http://localhost:3000).

Создание To Do List

Остановите приложение и установите пакет To Do List.

Шаг 1. Установка пакета

Загрузите пробный пакет To Do List и следуйте инструкциям в файле README. Пробная версия доступна только 30 дней.

Шаг 2. Создание компонента

Создайте Vue-компонент для добавления To Do List с Toolbar в приложение. В директории src/components/ создайте новый файл ToDo.vue.

Импорт исходных файлов

Откройте ToDo.vue и импортируйте исходные файлы To Do List. Выберите один из двух путей импорта:

  • PRO-версия, установленная из локальной папки - импорт из dhx-todolist-package
  • пробная версия - импорт из @dhx/trial-todolist

Пример ниже импортирует из PRO-пакета:

ToDo.vue
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>

В зависимости от пакета исходные файлы могут быть минифицированы. В таком случае импортируйте CSS-файл как todo.min.css.

Следующий фрагмент импортирует из пробного пакета:

ToDo.vue
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>

В этом руководстве используется пробная версия.

Настройка контейнеров и добавление To Do List с Toolbar

Чтобы отобразить To Do List с Toolbar на странице, создайте контейнеры для обоих компонентов и инициализируйте их с помощью конструкторов. Пример ниже инициализирует компоненты внутри хука mounted():

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
mounted() {
// инициализация компонента To Do List
this.todo = new ToDo(this.$refs.todo_container, {});

// инициализация компонента Toolbar
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api, // передача внутреннего API To Do List
// другие свойства конфигурации
});
},

unmounted() {
this.todo.destructor(); // уничтожение To Do List
this.toolbar.destructor(); // уничтожение Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Загрузка данных

Создайте файл data.js в директории src/ и добавьте в него данные. Следующий пример экспортирует функцию getData(), которая возвращает задачи, пользователей и проекты:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Откройте App.vue, импортируйте данные и инициализируйте их через внутренний метод data(). Передайте данные в компонент <ToDo/> как props:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

Перейдите в ToDo.vue и примените переданные props к объекту конфигурации To Do List. Фрагмент ниже передаёт данные пользователей, задач и проектов через конфигурацию:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {
users: this.users,
tasks: this.tasks,
projects: this.projects,
// другие свойства конфигурации
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// другие свойства конфигурации
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Вы также можете использовать метод parse() внутри mounted() для загрузки данных в To Do List. Пример ниже загружает данные с помощью parse() после инициализации:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// другие свойства конфигурации
});

this.todo.parse({
users: this.users,
tasks: this.tasks,
projects: this.projects
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Каждый вызов parse(data) заменяет текущий набор данных.

Теперь компонент отображает заполненный To Do List. Другие доступные свойства описаны в обзоре конфигурации.

Обработка событий

Подпишитесь на события, чтобы реагировать на действия пользователя. Смотрите полный список событий.

Откройте ToDo.vue и дополните метод mounted(). Фрагмент ниже прикрепляет обработчик к событию add-task:

ToDo.vue
<script>
// ...
export default {
// ...
mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.todo.api.on("add-task", ({ id }) => {
console.log("A new task is added", id);
});
},

unmounted() {
this.todo.destructor();
}
}
</script>

// ...

Шаг 3. Добавление To Do List в приложение

Чтобы добавить компонент в приложение, откройте App.vue и замените код по умолчанию следующим фрагментом:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

Запустите приложение. To Do List отобразится с тестовыми данными:

DHTMLX To Do List, отрендеренный в приложении Vue с демонстрационными данными

Полный проект доступен на GitHub.